function FindProxyForURL(url, host)
{
	var NO_AUTH_PROXY = ["dummy", "array"];
	var AUTH_PROXY  = ["dummy", "array"];
	var DIRECT_ACCESS_SITE = ["dummy", "array"];
	var NO_AUTH_ACCESS_SITE = ["dummy", "array"];
	var NEVER_ACCESS_SITE = ["dummy", "array"];
	
// set ENABLE_FAILOVER = 1  to instruct browsers to try check if any of the other proxy servers, are available if it's primary proxy server is down.
	var ENABLE_FAILOVER = 1 ; 

// set AUTH_SCHEME to 1 only if you are using NTLM, setting this to 0 will disable auto failover for authenticating proxies
	var AUTH_SCHEME = 1; 
	
// List of our proxy services that demand authentication for web access	
	
	AUTH_PROXY[0] = "10.0.4.39:3128" ;
	AUTH_PROXY[1] = "10.0.4.40:3128" ;
	AUTH_PROXY[2] = "10.0.4.43:3128" ;
	AUTH_PROXY[2] = "10.0.4.41:3128" ; 
	AUTH_PROXY[3] = "10.0.4.42:3128" ; 

// List of our proxy services that DO NOT demand authentication for web access	

	NO_AUTH_PROXY[0] = "10.0.4.11:3128" ;
	NO_AUTH_PROXY[1] = "10.0.4.40:3128" ;
	NO_AUTH_PROXY[2] = "10.0.4.43:3128" ;
	NO_AUTH_PROXY[2] = "10.0.4.41:8080" ;  
	NO_AUTH_PROXY[3] = "10.0.4.42:8080" ;  
	
// List of our web-sites that must be accessed DIRECTLY accessed ( without any proxy service) 	

	DIRECT_ACCESS_SITE[0] = "192.168.5.*" ;
	DIRECT_ACCESS_SITE[1] = "10.0.*" ;
	DIRECT_ACCESS_SITE[2] = "*.pxbazd005.*" ;
	DIRECT_ACCESS_SITE[3] = "*.samparkIT.*" ;
	DIRECT_ACCESS_SITE[4] = "*.futurebytes.*" ;
	DIRECT_ACCESS_SITE[5] = "*.fg.net.*" ;
	DIRECT_ACCESS_SITE[6] = "*.futurehrms.fg.net.*" ;
	DIRECT_ACCESS_SITE[7] = "160.*" ;

// List of our web-sites that must be accessible via proxy service, without any demand for authentication 

	NO_AUTH_ACCESS_SITE[0] = "*.google.*" ;
	NO_AUTH_ACCESS_SITE[1] = "*.microsoft.*" ;
	NO_AUTH_ACCESS_SITE[2] = "*.oe2000.*" ;
	NO_AUTH_ACCESS_SITE[3] = "*.safesquid.*" ;
	NO_AUTH_ACCESS_SITE[4] = "*.yahoo.*" ;
	NO_AUTH_ACCESS_SITE[5] = "*.msdn.*" ;
	NO_AUTH_ACCESS_SITE[6] = "*.linuxmag.*" ;
	NO_AUTH_ACCESS_SITE[7] = "*.howtoforge.*" ;

// List of  web-sites that are strictly banned, as accessing them is a total abuse of the Internet Resources.

	NEVER_ACCESS_SITE[0] = "*sex.*" ;
	NEVER_ACCESS_SITE[1] = "*.playboy.*" ;
	NEVER_ACCESS_SITE[2] = "*.desibaba.com" ;
	NEVER_ACCESS_SITE[3] = "*.warez.com" ;
	NEVER_ACCESS_SITE[4] = "*.erotica.com" ;
	NEVER_ACCESS_SITE[5] = "*.porn.com" ;
	NEVER_ACCESS_SITE[6] = "*.porn.net" ;
	NEVER_ACCESS_SITE[7] = "*.moresex.*" ;
	

// -------------------- Do not edit below this line -------------------- //

//	This is for direct connection
	var DO_NOT_USE_PROXY = "DIRECT";
	
//	This is to black hole requests that may overwhelm our Internet Resources, 	
	var BLACK_HOLE = "PROXY 127.0.0.1:65535";

// If this is a never access site black hole it

	for(count = 0; count < NEVER_ACCESS_SITE.length ; count++) {
		if (shExpMatch(host, NEVER_ACCESS_SITE[count]))
			return BLACK_HOLE;
	}
	


// if the hostname contains no dots, e.g. http://intranet it must be a local site that does not require a proxy service
	if (isPlainHostName(host)) 
		return "DIRECT";


// If this is a direct access site do not use proxy	
	for(count = 0; count < DIRECT_ACCESS_SITE.length ; count++) {
		if (shExpMatch(host, DIRECT_ACCESS_SITE[count]))
			return DO_NOT_USE_PROXY;
	}

	var auth_required=0;	

// Find out if we have to use a proxy that does not require authentication
	for(count = 0; count < NO_AUTH_ACCESS_SITE.length ; count++) {

		if (shExpMatch(host, NO_AUTH_ACCESS_SITE[count])) {
			auth_required = 1;
			break;
		}
	}
			
//  Load Balancing Code


// Find the 4th octet
	var myip=myIpAddress() ;
	var ipbits=myip.split(".") ;
	var myseg=parseInt(ipbits[3]) ;
	var DO_PROXY = "";
	var schemes = 1;

	if (auth_required == 1) {
		
		// check if failover is enabled
		if (ENABLE_FAILOVER == 1 ) {
			if (AUTH_SCHEME == 1 )
			schemes = NO_AUTH_PROXY.length ;
		}
		
		for ( i = 0; i < schemes ; i ++) {
			var proxy_hash = 0;
			count = myseg + i ;
			proxy_hash = (count % schemes) ;
			DO_PROXY="PROXY " + NO_AUTH_PROXY[proxy_hash] + "; "	+ DO_PROXY
		}
	}

	if (auth_required != 1 ) {
		
		// check if failover is enabled
		if (ENABLE_FAILOVER == 1 ) 
			schemes = AUTH_PROXY.length ;
		
		for ( i = 0; i < schemes ; i ++) {
			var proxy_hash = 0;
			count = myseg + i ;
			proxy_hash = (count % schemes) ;
			DO_PROXY="PROXY " + AUTH_PROXY[proxy_hash] + "; "	+ DO_PROXY
		}
	}

	return DO_PROXY;	
}
